#include "common.h"
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <string.h>

#ifdef __cplusplus
extern "C" {
#endif

int
LLVMFuzzerTestOneInput(const uint8_t *data, size_t size) {
    size_t i = 0;

    uint16_t uint16_eq_const_0_0;
    uint8_t uint8_eq_const_1_0;
    uint8_t uint8_eq_const_2_0;
    uint64_t uint64_eq_const_3_0;
    uint32_t uint32_eq_const_4_0;
    uint8_t uint8_eq_const_5_0;
    uint16_t uint16_eq_const_6_0;
    uint8_t uint8_eq_const_7_0;
    uint32_t uint32_eq_const_8_0;

    if (size < 24)
        return TEPHRA_EXIT_FAILURE;


    memcpy(&uint16_eq_const_0_0, &data[i], 2);
    i += 2;
    memcpy(&uint8_eq_const_1_0, &data[i], 1);
    i += 1;
    memcpy(&uint8_eq_const_2_0, &data[i], 1);
    i += 1;
    memcpy(&uint64_eq_const_3_0, &data[i], 8);
    i += 8;
    memcpy(&uint32_eq_const_4_0, &data[i], 4);
    i += 4;
    memcpy(&uint8_eq_const_5_0, &data[i], 1);
    i += 1;
    memcpy(&uint16_eq_const_6_0, &data[i], 2);
    i += 2;
    memcpy(&uint8_eq_const_7_0, &data[i], 1);
    i += 1;
    memcpy(&uint32_eq_const_8_0, &data[i], 4);
    i += 4;


    if (uint16_eq_const_0_0 == 34831)
    if (uint8_eq_const_1_0 == 228)
    if (uint8_eq_const_2_0 == 6)
    if (uint64_eq_const_3_0 == 8432561595244595009u)
    if (uint32_eq_const_4_0 == 1328813054)
    if (uint8_eq_const_5_0 == 39)
    if (uint16_eq_const_6_0 == 41096)
    if (uint8_eq_const_7_0 == 118)
    if (uint32_eq_const_8_0 == 2923746674)
        BOOM();

    return TEPHRA_EXIT_SUCCESS;
}

#ifdef __cplusplus
}
#endif
